import { jsxs as _, jsx as q } from "react/jsx-runtime";
import J, { useState as d, useMemo as E, useRef as f, useLayoutEffect as H, useImperativeHandle as K } from "react";
/*!
 * react-base-virtual-list
 * Author: phphe <phphe@outlook.com> (https://github.com/phphe)
 * Released under the MIT License.
 */
const Q = J.forwardRef, W = {
  /**
   * The visible space of the list. It is only used before DOM created(SSR).
   */
  listSize: 1e3,
  /**
   * Whether to enable the virtual list feature.
   */
  virtual: !0
}, X = Q(function(e, L) {
  var V, N;
  const [c, O] = d(e.itemSize || 100), S = E(() => e.buffer || Math.max(c * 5, 100), [e.buffer, c]), a = e.items.length, r = f(null), h = f(null), I = f(0), u = f(), [$, j] = d([]), [b, F] = d(0), [g, v] = d(e.listSize), [B, D] = d([]), x = f(!1), P = E(() => {
    var C;
    const n = c * a;
    let t = b - S, i = n - b - g - S, l = 0, s = 0;
    t <= 0 ? (t = 0, l = 0) : l = Math.floor(t / c), i < 0 && (i = 0), n <= g ? s = a : s = a - Math.floor(i / c), e.virtual || (l = 0, s = a);
    let o = Array.from({ length: s - l }, (m, R) => R + l).concat(e.persistentIndices || []);
    return (C = e.persistentIndices) != null && C.length && (o = [...new Set(o)].sort((m, R) => m - R)), { visible: o.map((m) => e.items[m]), visibleIndices: o, topSpace: t, bottomSpace: i, totalSpace: n };
  }, [e.items, c, a, b, S, g, e.virtual, e.persistentIndices]), { visible: U, visibleIndices: T, topSpace: k, bottomSpace: M, totalSpace: A } = P, z = { paddingTop: `${k}px`, boxSizing: "border-box" };
  M < c * 5 ? z.paddingBottom = `${M}px` : z.height = `${A}px`, H(() => {
    if (v(r.current.clientHeight), e.itemSize == null) {
      const n = h.current;
      let t = parseFloat(getComputedStyle(n).rowGap);
      t = isNaN(t) ? 0 : t;
      let i = 0, l = 0;
      const s = new Set(e.persistentIndices || []);
      let w = -1;
      for (const o of n.children) {
        if (w++, s.has(T[w]))
          continue;
        const y = getComputedStyle(o);
        l += o.offsetHeight + parseFloat(y.marginTop) + parseFloat(y.marginBottom) + t, i++;
      }
      O(l / i);
    }
  }, [e.itemSize, e.items, B]);
  const G = function(n) {
    var t;
    if (e.virtual && !u.current) {
      if (v(r.current.clientHeight), x.current)
        x.current = !1;
      else {
        const i = r.current.scrollTop;
        Math.abs(I.current - i) > (e.triggerDistance ?? c) && (F(i), I.current = i);
      }
      (t = e.onScroll) == null || t.call(this, n);
    }
  };
  return K(L, () => ({
    scrollToIndex(n, t = "start") {
      u.current = {
        index: n,
        block: t
      };
      const i = n * c;
      r.current.scrollTop = i, F(i), I.current = i, j([]);
    },
    getRootElement() {
      return r.current;
    },
    forceUpdate() {
      D([]);
    }
  }), [c]), H(() => {
    if (u.current) {
      const { index: n, block: t } = u.current;
      u.current = void 0;
      const i = T.indexOf(n), l = h.current.children[i];
      l && (l.scrollIntoView({ block: t }), x.current = !0);
    }
  }, [$]), H(() => {
    const { ResizeObserver: n } = window, t = n && new n(() => {
      v(r.current.clientHeight);
    });
    return t.observe(r.current), () => {
      t == null || t.disconnect();
    };
  }, []), /* @__PURE__ */ _("div", { ref: r, onScroll: G, className: e.className, style: { overflow: "auto", ...e.style }, children: [
    (V = e.renderHead) == null ? void 0 : V.call(e),
    /* @__PURE__ */ q("div", { ref: h, style: { display: "flex", flexDirection: "column", ...e.virtual && z }, children: U.map((n, t) => e.renderItem(n, T[t])) }),
    (N = e.renderFoot) == null ? void 0 : N.call(e)
  ] });
});
X.defaultProps = W;
export {
  X as VirtualList,
  W as defaultProps
};
